LNMMP平台搭建

nginx 反向代理服务器 172.16.58.3 

php-fpm PHP服务器 172.16.58.2
mysql 数据库服务器 172.16.58.5
httpd 静态页面服务器 172.16.58.1
memcached 缓存服务器 172.16.58.4
原则:
先实现再完善,所有平台通过网络套接字连接,以便后续的可扩展性,你也可以认为一台独立主机就是一个集群服务器
结构如图所示
wKioL1Nc9aCyi8euAAD60AwPumo523.jpg
------------------------------------------------------------------------------------------------------------------------
软件安装配置
一、安装MYSQL(mariadb)

1、下载软件包,这里是通用二进制安装包
# wget ftp://172.16.0.1/pub/Sources/6.x86_64/mariadb/mariadb-10.0.10-linux-x86_64.tar.gz

2、解压至/etc/local/目录下,并在此目录下创建链接。
# tar xf mariadb-10.0.10-linux-x86_64.tar.gz -C /usr/local/

3、参考通用二进制安装方式安装即可,这里不再演示。

4、结果
安装目录
/usr/local/mysql   
数据目录
/mydata/data/
配置文件
# vim /etc/my.cnf
---------------------------------------------------------
# Try number of CPU's*2 for thread_concurrency
thread_concurrency = 4
datadir=/mydata/data
innodb_file_per_table = ON
log-bin=/mydata/binlogs/master-bin
binlog_format=mixed
server-id       = 1
--------------------------------------------------------------------    
5、初始化MYSQL数据库,创建授权帐号。
# service mysqld start
MariaDB [mysql]> grant all on *.* to "google"@"172.16.58.%" identified by "google";

、安装PHP

1、解决依赖关系:

请配置好yum源(可以是本地系统光盘)后执行如下命令:
# yum -y groupinstall "Development Tools" 
# yum install -y libxml2-devel  openssl-devel  bzip2-devel libcurl-devel  mcrypt  libmcrypt-devel

2、安装php-5.4.26

首先下载源码包至本地目录

# tar xf php-5.4.26.tar.bz2
# cd php-5.4.26
#  ./configure --prefix=/usr/local/php --with-mysql=mysqlnd --with-openssl --with-mysqli=mysqlnd --enable-mbstring --with-freetype-dir --with-jpeg-dir --with-png-dir --with-zlib --with-libxml-dir=/usr --enable-xml  --enable-sockets --enable-fpm --with-mcrypt  --with-config-file-path=/etc --with-config-file-scan-dir=/etc/php.d --with-bz2 --with-pdo-mysql=mysqlnd --enable-sysvshm --with-mhash --with-curl 

# make
# make intall

为php提供配置文件:
# cp php.ini-production /etc/php.ini

为php-fpm提供Sysv init脚本,并将其添加至服务列表:
# cp sapi/fpm/init.d.php-fpm  /etc/rc.d/init.d/php-fpm
# chmod +x /etc/rc.d/init.d/php-fpm
# chkconfig --add php-fpm
# chkconfig php-fpm on

为php-fpm提供配置文件:
# cp /usr/local/php/etc/php-fpm.conf.default /usr/local/php/etc/php-fpm.conf 

编辑php-fpm的配置文件:
# vim /usr/local/php/etc/php-fpm.conf
配置fpm的相关选项为你所需要的值,并启用pid文件(如下最后一行):
pm.max_children = 150
pm.start_servers = 8
pm.min_spare_servers = 5
pm.max_spare_servers = 10
pid = /usr/local/php/var/run/php-fpm.pid 
listen =172.16.58.2:9000

接下来就可以启动php-fpm了:
# service php-fpm start

使用如下命令来验正
# ss -tunl
tcp   LISTEN     0      128           172.16.58.2:9000                   *:*     

3、安装xcache ,为php加速

1、安装
# tar xf xcache-3.1.0.tar.gz
# cd xcache-3.1.0
# /usr/local/php/bin/phpize
# ./configure --enable-xcache --with-php-config=/usr/local/php/bin/php-config
# make && make install

安装结束时,会出现类似如下行:
Installing shared extensions:     /usr/local/php/lib/php/extensions/no-debug-zts-20100525/

2、编辑php.ini,整合php和xcache:

首先将xcache提供的样例配置导入php.ini
# mkdir /etc/php.d
# cp xcache.ini /etc/php.d

说明:xcache.ini文件在xcache的源码目录中。

接下来编辑/etc/php.d/xcache.ini,找到extension开头的行,修改为如下行:
extension = /usr/local/php/lib/php/extensions/no-debug-zts-20100525/xcache.so

注意:如果php.ini文件中有多条extension指令行,要确保此新增的行排在第一位。

3、重新启动php-fpm
# service php-fpm restart

三、安装httpd

1、解决依赖关系

httpd-2.4.9需要较新版本的 aprapr-util,这里选择使用编译源代码的方式进行。

(1)编译安装 apr


# tar xf apr-1.5.0.tar.bz2
# cd apr-1.5.0
# ./configure --prefix=/usr/local/apr
# make && make install

(2)编译安装 apr-util


# tar xf apr-util-1.5.3.tar.bz2
# cd apr-util-1.5.3
# ./configure --prefix=/usr/local/apr-util --with-apr=/usr/local/apr
# make && make install

(3) httpd-2.4.9编译过程也要依赖于 pcre-developenssl-devel软件包,需要事先安装。此软件包系统光盘自带,因此,找到并安装即可。

2、编译安装 httpd-2.4.9


首先下载 httpd-2.4.9到本地,而后执行如下命令进行编译安装过程:

# tar xf httpd-2.4.9.tar.bz2
# cd httpd-2.4.9
# ./configure --prefix=/usr/local/apache --sysconfdir=/etc/httpd --enable-so --enable-ssl --enable-cgi --enable-rewrite --with-zlib --with-pcre --with-apr=/usr/local/apr --with-apr-util=/usr/local/apr-util --enable-modules=most --enable-mpms-shared=all --with-mpm=event
# make && make install

3 、修改 httpd 的主配置文件,设置其 Pid 文件的路径
编辑 /etc/httpd/httpd.conf ,添加如下行即可:
PidFile  "/var/run/httpd.pid"

4、提供 SysV服务脚本 /etc/rc.d/init.d/httpd,内容如下:
-------------------------------------------------------------------------------------------------
#!/bin/bash
#
# httpd        Startup script for the Apache HTTP Server
#
# chkconfig: - 85 15
# description: Apache is a World Wide Web server.  It is used to serve \
#        HTML files and CGI.
# processname: httpd
# config: /etc/httpd/conf/httpd.conf
# config: /etc/sysconfig/httpd
# pidfile: /var/run/httpd.pid

# Source function library.
. /etc/rc.d/init.d/functions

if [ -f /etc/sysconfig/httpd ]; then
        . /etc/sysconfig/httpd
fi

# Start httpd in the C locale by default.
HTTPD_LANG=${HTTPD_LANG-"C"}

# This will prevent initlog from swallowing up a pass-phrase prompt if
# mod_ssl needs a pass-phrase from the user.
INITLOG_ARGS=""

# Set HTTPD=/usr/sbin/httpd.worker in /etc/sysconfig/httpd to use a server
# with the thread-based "worker" MPM; BE WARNED that some modules may not
# work correctly with a thread-based MPM; notably PHP will refuse to start.

# Path to the apachectl script, server binary, and short-form for messages.
apachectl=/usr/local/apache/bin/apachectl
httpd=${HTTPD-/usr/local/apache/bin/httpd}
prog=httpd
pidfile=${PIDFILE-/var/run/httpd.pid}
lockfile=${LOCKFILE-/var/lock/subsys/httpd}
RETVAL=0

start() {
        echo -n $"Starting $prog: "
        LANG=$HTTPD_LANG daemon --pidfile=${pidfile} $httpd $OPTIONS
        RETVAL=$?
        echo
        [ $RETVAL = 0 ] && touch ${lockfile}
        return $RETVAL
}

stop() {
  echo -n $"Stopping $prog: "
  killproc -p ${pidfile} -d 10 $httpd
  RETVAL=$?
  echo
  [ $RETVAL = 0 ] && rm -f ${lockfile} ${pidfile}
}
reload() {
    echo -n $"Reloading $prog: "
    if ! LANG=$HTTPD_LANG $httpd $OPTIONS -t >&/dev/null; then
        RETVAL=$?
        echo $"not reloading due to configuration syntax error"
        failure $"not reloading $httpd due to configuration syntax error"
    else
        killproc -p ${pidfile} $httpd -HUP
        RETVAL=$?
    fi
    echo
}

case "$1" in
  start)
  start
  ;;
  stop)
  stop
  ;;
  status)
        status -p ${pidfile} $httpd
  RETVAL=$?
  ;;
  restart)
  stop
  start
  ;;
  condrestart)
  if [ -f ${pidfile} ] ; then
    stop
    start
  fi
  ;;
  reload)
        reload
  ;;
  graceful|help|configtest|fullstatus)
  $apachectl $@
  RETVAL=$?
  ;;
  *)
  echo $"Usage: $prog {start|stop|restart|condrestart|reload|status|fullstatus|graceful|help|configtest}"
  exit 1
esac

exit $RETVAL
------------------------------------------------------------------------------------------------- 

而后为此脚本赋予执行权限:
# chmod +x /etc/rc.d/init.d/httpd

加入服务列表:
# chkconfig --add httpd

接下来就可以启动服务进行测试了。

四、安装nginx

1、解决依赖关系

编译安装nginx需要事先需要安装开发包组"Development Tools"。
# yum -y groupinstall " Development Tools "
# yum -y install pcre-devel

2、安装

首先添加用户nginx,实现以之运行nginx服务进程:
# groupadd -r nginx
# useradd -r -g nginx nginx

接着开始编译和安装:
# ./configure \
  --prefix=/usr/local/nginx \
  --sbin-path=/usr/local/nginx/sbin/nginx \
  --conf-path=/etc/nginx/nginx.conf \
  --error-log-path=/var/log/nginx/error.log \
  --http-log-path=/var/log/nginx/access.log \
  --pid-path=/var/run/nginx/nginx.pid  \
  --lock-path=/var/lock/nginx.lock \
  --user=nginx \
  --group=nginx \
  --with-http_ssl_module \
  --with-http_flv_module \
  --with-http_stub_status_module \
  --with-http_gzip_static_module \
  --http-client-body-temp-path=/var/tmp/nginx/client/ \
  --http-proxy-temp-path=/var/tmp/nginx/proxy/ \
  --http-fastcgi-temp-path=/var/tmp/nginx/fcgi/ \
  --http-uwsgi-temp-path=/var/tmp/nginx/uwsgi \
  --http-scgi-temp-path=/var/tmp/nginx/scgi \
  --with-pcre
# make && make install

3、为nginx提供SysV init脚本:

新建文件/etc/rc.d/init.d/nginx,内容如下:
-------------------------------------------------------------------------------------------
#!/bin/sh
#
# nginx - this script starts and stops the nginx daemon
#
# chkconfig:   - 85 15 
# description:  Nginx is an HTTP(S) server, HTTP(S) reverse \
#               proxy and IMAP/POP3 proxy server
# processname: nginx
# config:      /etc/nginx/nginx.conf
# config:      /etc/sysconfig/nginx
# pidfile:     /var/run/nginx.pid
# Source function library.
. /etc/rc.d/init.d/functions
# Source networking configuration.
. /etc/sysconfig/network
# Check that networking is up.
[ "$NETWORKING" = "no" ] && exit 0
nginx="/usr/sbin/nginx"
prog=$(basename $nginx)
NGINX_CONF_FILE="/etc/nginx/nginx.conf"
[ -f /etc/sysconfig/nginx ] && . /etc/sysconfig/nginx
lockfile=/var/lock/subsys/nginx
make_dirs() {
   # make required directories
   user=`nginx -V 2>&1 | grep "configure arguments:" | sed 's/[^*]*--user=\([^ ]*\).*/\1/g' -`
   options=`$nginx -V 2>&1 | grep 'configure arguments:'`
   for opt in $options; do
       if [ `echo $opt | grep '.*-temp-path'` ]; then
           value=`echo $opt | cut -d "=" -f 2`
           if [ ! -d "$value" ]; then
               # echo "creating" $value
               mkdir -p $value && chown -R $user $value
           fi
       fi
   done
}
start() {
    [ -x $nginx ] || exit 5
    [ -f $NGINX_CONF_FILE ] || exit 6
    make_dirs
    echo -n $"Starting $prog: "
    daemon $nginx -c $NGINX_CONF_FILE
    retval=$?
    echo
    [ $retval -eq 0 ] && touch $lockfile
    return $retval
}
stop() {
    echo -n $"Stopping $prog: "
    killproc $prog -QUIT
    retval=$?
    echo
    [ $retval -eq 0 ] && rm -f $lockfile
    return $retval
}
restart() {
    configtest || return $?
    stop
    sleep 1
    start
}
reload() {
    configtest || return $?
    echo -n $"Reloading $prog: "
    killproc $nginx -HUP
    RETVAL=$?
    echo
}
force_reload() {
    restart
}
configtest() {
  $nginx -t -c $NGINX_CONF_FILE
}
rh_status() {
    status $prog
}
rh_status_q() {
    rh_status >/dev/null 2>&1
}
case "$1" in
    start)
        rh_status_q && exit 0
        $1
        ;;
    stop)
        rh_status_q || exit 0
        $1
        ;;
    restart|configtest)
        $1
        ;;
    reload)
        rh_status_q || exit 7
        $1
        ;;
    force-reload)
        force_reload
        ;;
    status)
        rh_status
        ;;
    condrestart|try-restart)
        rh_status_q || exit 0
            ;;
    *)
        echo $"Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload|configtest}"
        exit 2
esac
-------------------------------------------------------------------------------------------
而后为此脚本赋予执行权限:
# chmod +x /etc/rc.d/init.d/nginx

添加至服务管理列表,并让其开机自动启动:
# chkconfig --add nginx
# chkconfig nginx on

而后就可以启动服务并测试了:
# service nginx start

五、nginx做反向代理

nginx向后代理与httpd服务器结合

1、编辑 /etc/nginx/nginx.conf,在http下的server段中添加如下内容
location ~ \.html$ {
            proxy_pass   http://172.16.58.1;
        }
表示所有html结尾的请求都转向后端服务器

而后重新载入nginx的配置文件:
# service nginx reload

2、在httpd服务器,编辑页面文件
# vim /usr/local/apache/htdocs/index.html 

<h1>This is httpd server</h1>

3、通过浏览器访问此测试页面
wKiom1Nc9hDzct9AAADBsx0Fic8532.jpg
    nginx基于fcgi方式与php服务器结合

1、编辑/etc/nginx/nginx.conf,启用如下选项:
location ~ \.php$ {
            root           html;
            fastcgi_pass   172.16.58.2:9000;
            fastcgi_index  index.php;
            fastcgi_param  SCRIPT_FILENAME  /scripts$fastcgi_script_name;
            include        fastcgi_params;
        }

2、编辑/etc/nginx/fastcgi_params,将其内容更改为如下内容:
fastcgi_param  GATEWAY_INTERFACE  CGI/1.1;
fastcgi_param  SERVER_SOFTWARE    nginx;
fastcgi_param  QUERY_STRING       $query_string;
fastcgi_param  REQUEST_METHOD     $request_method;
fastcgi_param  CONTENT_TYPE       $content_type;
fastcgi_param  CONTENT_LENGTH     $content_length;
fastcgi_param  SCRIPT_FILENAME    $document_root$fastcgi_script_name;
fastcgi_param  SCRIPT_NAME        $fastcgi_script_name;
fastcgi_param  REQUEST_URI        $request_uri;
fastcgi_param  DOCUMENT_URI       $document_uri;
fastcgi_param  DOCUMENT_ROOT      $document_root;
fastcgi_param  SERVER_PROTOCOL    $server_protocol;
fastcgi_param  REMOTE_ADDR        $remote_addr;
fastcgi_param  REMOTE_PORT        $remote_port;
fastcgi_param  SERVER_ADDR        $server_addr;
fastcgi_param  SERVER_PORT        $server_port;
fastcgi_param  SERVER_NAME        $server_name;

并在所支持的主页面格式中添加php格式的主页,类似如下:
location / {
            root   html;
            index  index.php index.html index.htm;
        }
而后重新载入nginx的配置文件:
# service nginx reload

3、在 PHP服务器/usr/html新建index.php的测试页面,测试php是否能正常工作:
# vim /usr/html/index.php

<h1>This is PHP server<h1>
<?php
        $link = mysql_connect("172.16.58.5","google","google");
        if ($link)
                echo "MYSQL with PHP is connected";
        else
                echo "PHP can`t connect with MYSQL";
        mysql_close();
        phpinfo();
?>

接着就可以通过浏览 器访问此测试页面了。

wKioL1Nc9kmBnswXAAEiy2JpPGA902.jpg

 

有下面此项说明PHP的 Xcache加速器安装完成,并生效。
wKiom1Nc9wehQQs3AAItGbvR4Vg952.jpg

至此LNMP平台就算搭建完成,下面开始搭建memcached服务器并尝试多种结合方式。

六、安装memcached

Memcached是一款开源、高性能、分布式内存对象缓存系统,可应用各种需要缓存的场景,其主要目的是通过降低对Database的访问来加速web应用程序。它是一个基于内存的“键值对”存储,用于存储数据库调用、API调用或页面引用结果的直接数据,如字符串、对象等。

1、解决依赖关系

memcached依赖于libevent API,因此要事先安装之,本文采用的是源码包libevent-2.0.21-stable.tar.gz

# tar xf libevent-2.0.21-stable.tar.gz
# cd libevent-2.0.21
# ./configure --prefix=/usr/local/libevent
# make && make install

# echo "/usr/local/libevent/lib" > /etc/ld.so.conf.d/libevent.conf
# ldconfig 

2、安装配置memcached

安装memcached
# tar xf memcached-1.4.15.tar.gz 
# cd memcached-1.4.15
# ./configure --prefix=/usr/local/memcached --with-libevent=/usr/local/libevent
# make && make install

memcached SysV的startup脚本代码如下所示,将其建立为/etc/init.d/memcached文件:
-------------------------------------------------------------------------------------------------------------------------------
#!/bin/bash
#
# Init file for memcached
#
# chkconfig: - 86 14
# description: Distributed memory caching daemon
#
# processname: memcached
# config: /etc/sysconfig/memcached

. /etc/rc.d/init.d/functions

## Default variables
PORT="11211"
USER="nobody"
MAXCONN="1024"
CACHESIZE="64"

RETVAL=0
prog="/usr/local/memcached/bin/memcached"
desc="Distributed memory caching"
lockfile="/var/lock/subsys/memcached"

start() {
        echo -n $"Starting $desc (memcached): "
        daemon $prog -d -p $PORT -u $USER -c $MAXCONN -m $CACHESIZE
        RETVAL=$?
        [ $RETVAL -eq 0 ] && success && touch $lockfile || failure
        echo
        return $RETVAL
}

stop() {
        echo -n $"Shutting down $desc (memcached): "
        killproc $prog
        RETVAL=$?
        [ $RETVAL -eq 0 ] && success && rm -f $lockfile || failure
        echo
        return $RETVAL
}

restart() {
        stop
        start
}

reload() {
        echo -n $"Reloading $desc ($prog): "
        killproc $prog -HUP
        RETVAL=$?
        [ $RETVAL -eq 0 ] && success || failure
        echo
        return $RETVAL
}

case "$1" in
  start)
        start
        ;;
  stop)
        stop
        ;;
  restart)
        restart
        ;;
  condrestart)
        [ -e $lockfile ] && restart
        RETVAL=$?
        ;;       
  reload)
        reload
        ;;
  status)
        status $prog
        RETVAL=$?
        ;;
   *)
        echo $"Usage: $0 {start|stop|restart|condrestart|status}"
        RETVAL=1
esac

exit $RETVAL
-------------------------------------------------------------------------------------------------------------------------------

使用如下命令配置memcached成为系统服务:
# chmod +x /etc/init.d/memcached
# chkconfig --add memcached
# service memcached start

3、使用telnet命令测试memcached的使用

# telnet 127.0.0.1 11211

add命令:
add keyname flag  timeout  datasize
添加一个测试项
add mykey 0 10 12
Hello world!

get命令:
get keyname
测试结果
get mykey
-----------------------
VALUE mykey 0 12
Hello world!
END
-----------------------
至此memcached服务搭建完成。

七、memcached与PHP结合

    结构图中第3种结合方式

1、在 PHP服务器上安装PHP的memcache扩展

# tar xf memcache-2.2.7.tgz
# cd memcache-2.2.7
# /usr/local/php/bin/phpize
# ./configure --with-php-config=/usr/local/php/bin/php-config --enable-memcache
# make && make install

上述安装完后会有类似以下的提示:

Installing shared extensions:     /usr/local/php/lib/php/extensions/no-debug-non-zts-20090626/

②编辑/etc/php.ini,在“动态模块”相关的位置添加如下一行来载入memcache扩展:
extension=/usr/local/php/lib/php/extensions/no-debug-non-zts-20090626/memcache.so

而后对memcached功能进行测试,在网站目录中/usr/html/建立测试页面test.php,添加如下内容:
<?php
$mem = new Memcache;
$mem->connect(" 172.16.58.4", 11211)  or die("Could not connect");

$version = $mem->getVersion();
echo "Server's version: ".$version."<br/>\n";

$mem->set('hellokey', 'Hello World', 0, 600) or die("Failed to save data at the memcached server");
echo "Store data in the cache (data will expire in 600 seconds)<br/>\n";

$get_result = $mem->get('hellokey');
echo "$get_result is from memcached server.";         
?>

如果有输出“Hello World is from memcached server”等信息,则表明memcache已经能够正常工作。
wKioL1Nc9w6C_6xhAADxRU3J_Yk570.jpg
查看PHP主页关于memcached的信息。
wKiom1Nc906iaSRWAAEOQsCvzqo587.jpg
八、memcached与nginx结合
    结构图中第1种结合方式
编辑nginx的配置文件
server段中修改为如下所示
这段的意思是先去缓存中查找,缓存中没有就通过代理到后端服务器上查找
location~\.html$ {
                set $memcached_key $uri;
                memcached_pass 172.16.58.4:11211;
                default_type    text/html;
                error_page      404@fallback;
        }

        location @fallback {
            proxy_pass   http://172.16.58.1;
        }
至此LNMMP平台就搭建完毕,至于memcached与mysql的结合依赖php程序自身,可惜我不会写程序j_0012.gif只好作罢,至少搭建好了memcached环境,后续会基于此平台进行扩充和测试。

 

你可能感兴趣的:(memcached,lnmmp)